// JavaScript Document
function parse_query_string(query) {
	var vars = query.split("&");
	var query_string = {};
	for (var i = 0; i < vars.length; i++) {
		var pair = vars[i].split("=");
		// If first entry with this name
		if (typeof query_string[pair[0]] === "undefined") {
			query_string[pair[0]] = decodeURIComponent(pair[1]);
			// If second entry with this name
		} else if (typeof query_string[pair[0]] === "string") {
			var arr = [query_string[pair[0]], decodeURIComponent(pair[1])];
			query_string[pair[0]] = arr;
			// If third or later entry with this name
		} else {
			query_string[pair[0]].push(decodeURIComponent(pair[1]));
		}
	}
	return query_string;
}
jQuery(document).ready(function ($) {



	$('.woo_inst_checkout_options').on('click', function () {
		if ($(this).is(':checked')) {
			$(this).parent().addClass('selected');
		} else {
			$(this).parent().removeClass('selected');
		}
	});

	$('.wpinbox_settings_div a.nav-tab').click(function () {
		$(this).siblings().removeClass('nav-tab-active');
		$(this).addClass('nav-tab-active');
		$('.nav-tab-content').hide();
		$('.nav-tab-content').eq($(this).index()).show();
		window.history.replaceState('', '', wp_inbox.this_url + '&t=' + $(this).index());


	});

	$('#wp_inbox_add_dept').on('click', function () {

		var wp_inbox_dept_title = $('#wp_inbox_dept_title').val();

		if ($.trim(wp_inbox_dept_title) != '') {

			var data = {
				'action': 'wpinboxdeptadd',
				'wp_inbox_dept_id': $('#wp_inbox_dept_id').val(),
				'wp_inbox_dept_title': wp_inbox_dept_title,
				'wp_inbox_dept_desc': $('#wp_inbox_dept_desc').val()
			};

			$.post(ajaxurl, data, function (response) {

				$('#wp_inbox_dept_title, #wp_inbox_dept_desc').val('');
				document.location.href = wp_inbox.this_url + '&t=' + $('.wpinbox_settings_div a.nav-tab-active').index();

			});
		}

	});

	$('.wp_inbox_department_edit').on('click', function () {
		var obj = $(this).parents().eq(1);
		obj.parent().find('.selected').removeClass('selected');
		obj.addClass('selected');

		$('#wp_inbox_dept_id').val($(this).data('key'));
		$('#wp_inbox_dept_title').val(obj.find('td').eq(0).html());
		$('#wp_inbox_dept_desc').val(obj.find('td').eq(1).html());
		$('#wp_inbox_add_dept').html('Update');
		$('div.wp_inbox_add_dept').show();
		$('button.wp_inbox_add_dept').hide();
		$('.add_edit').show();
		$('.staff-members').hide();
	});

	$('button.wp_inbox_add_dept, a.wp_inbox_add_dept').on('click', function () {
		$('div.wp_inbox_add_dept').show();
		$('button.wp_inbox_add_dept').hide();
		$('.staff-members').hide();
		$('#wp_inbox_dept_id, #wp_inbox_dept_title, #wp_inbox_dept_desc').val('');
		$('#wp_inbox_add_dept').html('Add');
		$('.add_edit').hide();
	});


	$('.wp_inbox_department_delete').on('click', function () {
		var obj = $(this).parents().eq(1);

		var ask = confirm("Are you sure, you want to delete?");

		if (ask) {
			var data = {
				'action': 'wpinboxdeptdelete',
				'wp_inbox_dept_id': $(this).data('key')
			};

			obj.fadeOut();

			$.post(ajaxurl, data, function (response) {

				obj.remove();

			});
		}
	});


	$('.wp_inbox_department_staff').on('click', function () {

		var obj = $(this).parents().eq(1);
		obj.parent().find('.selected').removeClass('selected');
		obj.addClass('selected');

		var data = {
			'action': 'wpinboxdeptstaff',
			'wp_inbox_dept_id': $(this).data('key')
		};


		if ($(this).data('key') != '') {
			$('.staff-members').show();
		} else {
			$('.staff-members').hide();
		}

		$('input[name="wp_inbox_dept_staff"]').val($(this).data('key'));

		$('.staff-members input[name^="wp_inbox_dept"]').prop('disabled', true);

		$('.staff-members input[name^="wp_inbox_dept"]').prop('checked', false);

		$('div.wp_inbox_add_dept').hide();
		$('button.wp_inbox_add_dept').show();

		$.post(ajaxurl, data, function (response) {

			response = $.parseJSON(response);
			var staff = response.staff;


			$('.staff-members input[name^="wp_inbox_dept"]').prop('disabled', false);

			$.each(staff, function (i, v) {

				$('.staff-members input[name="wp_inbox_dept[' + v + ']').prop('checked', true);

			});

		});

	});

	var query = window.location.search.substring(1);
	var qs = parse_query_string(query);
	if (typeof (qs.t) != 'undefined') {
		$('.wpinbox_settings_div a.nav-tab').eq(qs.t).click();
	}
	if ($('.wpinbox_settings_div').length > 0)
		$('.wpinbox_settings_div').show();

	$('.wpinbox_settings_div').on('click', '.advance_settings ul li > a', function () {
		$(this).parent().find('div').toggle();
	});
	$('.wpinbox_settings_div').on('click', '.advance_settings ul li > div img', function () {
		window.open($(this).attr('src'));
	});

	$('.wp_copy_author').on('click', function () {

		var txt, r;


		var data = {
			'action': 'wp_copy_author_file',
		}

		$.post(ajaxurl, data, function (response, status) {
			if (status == 'success') {
				if(response.is_error != 'yes'){

					if (response.file_exist == 'yes') {
						$('.wp-inbox-modal').modal('show')
					}

					if(response.file_copy == 'yes'){
						alert('file coppied');
					}

				}else{
					alert(response.error);
				}
			}
		});

		

	});

	$('.author_replace_confirm').on('click', function () {
		
		$('.wp-inbox-modal').modal('hide');
		var data = {
			'action': 'wp_copy_author_file',
			'replace_file': 'yes',
		}

		$.post(ajaxurl, data, function (response, status) {
			if (status == 'success') {
				if(response.is_error != 'yes'){


					if (response.file_exist == 'yes' && response.file_copy == 'yes') {
						
						alert('file coppied');					

					}

				}else{

					alert(response.error);

				}
			}
		});

		

	});


	$('.live_chat_settings_container input:checkbox.live_chat_settings').on('change', function(){

		var wp_inbox_live_chat_settings =  {};
		var checkboxes = $('.live_chat_settings_container input:checkbox.live_chat_settings');
		var success_msg = $('.live_chat_settings_container .success_msg');

		$.each(checkboxes, function(){

			var value = $(this).prop('checked') ? 'on' : 'off';
			var name = $(this).prop('name');

			wp_inbox_live_chat_settings[name] = value;


		});



		var data = {
			'action' : 'wp_inbox_ajax_save_settings',
			'wp_inbox_live_chat_settings': wp_inbox_live_chat_settings,
			'wp_inbox_nonce_field' : wp_inbox.wp_inbox_nonce_field

		}

		$.post(ajaxurl, data, function(response, code){

			if(code == 'success' && response == 'saved'){

				success_msg.show();

				setTimeout(function(){
					success_msg.fadeOut();
				}, 5000);

			}
		});

	});



	
});